PerfectHit = {spellHit = 0,meleeHit = 53.4}

local pName = "PerfectHit"

local f = CreateFrame("frame")

local ldb = LibStub:GetLibrary("LibDataBroker-1.1")

local dataobj = ldb:NewDataObject(pName, {
  type = "data source",
  text = "0% hit",
-- Spell_Shadow_FingerOfDeath.blp   "Interface\\Icons\\Spell_Lightning_LightningBolt01", 
  --icon = "Interface\\AddOns\\PerfectHit\\icon.tga"
  icon = "Interface\\Icons\\Ability_Mage_FrostFireBolt"
})


f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("PLAYER_TARGET_CHANGED")
f:RegisterEvent("PLAYER_TALENT_UPDATE")
f:RegisterEvent("UNIT_AURA")
f:RegisterEvent("UNIT_INVENTORY_CHANGED")
f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("PLAYER_LOGOUT")

local hit,hitLvl,hitStuff,hitDebuff,hitHero,hitTalent,hitStuffRating  = 0,0,0,0,0,0,0;
local hitMeleeTalent,hitMeleeLvl,hitMeleeStuff = 0,0,0;
local hitMeleeDual = 19;
local targetlvl = 1;
local spellDisplay = true;
local twoHandedWeaponEquipped = false;

-- base hit based on level (start at -4)
local hitBaseLvl = {100, 99, 98, 97, 96, 95, 94, 83, 72, 61};
local hitBaseLvlPvp = {100, 99, 98, 97, 96, 95, 94, 87, 80, 73};

-- retrieve locale name for target debuf and heroic presence
local debuffNameMisery = GetSpellInfo(33198);
--local debuffNameFaerie = GetSpellInfo(33602);
local debuffNameFaerie = GetSpellInfo(21670);
local debuffNameHeroic = GetSpellInfo(28878);


-- retrieve first numerical value from string
local function getValueFromString(str)
	if (str == nil) then return nil end
	for value in string.gmatch(str, "%d+") do 
		return tonumber(value)
	end
end

local tableTwoHandedSpell = {197,199,202}

local function RefreshTwoHandedWeapon()
	local mainHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot"))
	if (not mainHandLink) then 
		twoHandedWeaponEquipped = false;
		return false end
   	local _,_,_,_,_,_,subtype = GetItemInfo(mainHandLink);
   	--print("main hand : ", subtype)
    for _,id in ipairs(tableTwoHandedSpell) do
       local name = GetSpellInfo(id)	
       if (name == subtype) then 
	   	   twoHandedWeaponEquipped = true
		   return true
	   	
	   	end
    end
    twoHandedWeaponEquipped = false
   	return false
end

local function refreshDisplay()
	
    if (spellDisplay) then
		hit = PerfectHit.spellHit
		dataobj.icon = "Interface\\Icons\\Ability_Mage_FrostFireBolt"
	else
		hit = PerfectHit.meleeHit
		dataobj.icon = "Interface\\Icons\\Ability_BackStab"
	end

	local color = "|cff00FF00";
	if (hit<90) then color = "|cffFF2000"; 
	else if (hit<100) then color = "|cffFFFF00"; end
end


if (spellDisplay) then dataobj.text = format("%s%.1f%%", color,hit);
else  dataobj.text = format("%s%.1f%%(%.1f%%)", color,hit,hit-hitMeleeDual);
end

end

f:SetScript("OnEvent", function(self, event, arg1,...)

if (event == "PLAYER_LOGOUT") then
   --print("logout")
   PerfectHitSave.spellDisplay = spellDisplay;
   return;
end

if (event == "ADDON_LOADED" and arg1 == "PerfectHit") then
	if (PerfectHitSave == nil) then
		PerfectHitSave = {}
		PerfectHitSave.spellDisplay = true
		end
   spellDisplay = PerfectHitSave.spellDisplay
   --print("saved variable ",spellDisplay)
   
   return;
end

--print("event ",event,arg1 );
-- test for filtering uninteresting events
if (event == "UNIT_AURA") then
	if ((arg1 ~= "player") and (arg1 ~= "target")) then
	    --print("event trashed");
		return;
	end
 end

local eventAuraTarget = (event == "UNIT_AURA") and (arg1 == "target")
local eventAuraPlayer = (event == "UNIT_AURA") and (arg1 == "player")


-- hitLvl
--if (event == "PLAYER_TARGET_CHANGED") then
targetlvl = UnitLevel("target");
if (targetlvl == -1) then targetlvl = 83; end 
if (targetlvl == 0) then targetlvl = UnitLevel("player") end
local deltaLvl = targetlvl - UnitLevel("player");

--spell hit
if (UnitPlayerControlled("target")) then
    hitLvl = hitBaseLvlPvp[deltaLvl+5];
else
	hitLvl = hitBaseLvl[deltaLvl+5];
end
if (hitLvl == nil) then
	if (deltaLvl < 0) then hitLvl = 100;
	else hitLvl = 1; end
end
-- melee hit
local missMelee = 0;
if ((deltaLvl>-3) and (deltaLvl<3)) then
	 missMelee = 5 + deltaLvl*0.2;
else
	 missMelee = 6 + (deltaLvl-2)*2;
end
hitMeleeLvl = 100 - missMelee;
--print(hitMeleeLvl)

--end

-- hitStuff
hitStuff = GetCombatRatingBonus(CR_HIT_SPELL) ;
hitMeleeStuff = GetCombatRatingBonus(CR_HIT_MELEE);
hitStuffRating = GetCombatRating(CR_HIT_SPELL); 

if ((event == "PLAYER_TARGET_CHANGED") or (event == "UNIT_INVENTORY_CHANGED")) then  
    RefreshTwoHandedWeapon();
end
    
-- hitTalent 
if ((event == "PLAYER_TALENT_UPDATE") 
	or (event == "PLAYER_ENTERING_WORLD")
	or (event == "PLAYER_TARGET_CHANGED")) then

local _, englishClass = UnitClass("player");
--print(englishClass)

if (englishClass == "MAGE") then
-- precision
nameTalent, _, _, _, currentRank, maxRank = GetTalentInfo(3, 6);
hitTalent = currentRank;
--print(" hit talent : " .. nameTalent .. " rank " .. currentRank);
-- focalisation des arcanes
nameTalent, _, _, _, currentRank, maxRank = GetTalentInfo(1, 2);
hitTalent = hitTalent + currentRank;
--print(" hit talent : " .. nameTalent .. " rank " .. currentRank);
--print(hitTalent .. " % from talents");
elseif (englishClass == "PRIEST") then
-- shadow focus
nameTalent, _, _, _, currentRank, maxRank = GetTalentInfo(3, 6);
hitTalent = currentRank;
--print(" hit talent : " .. nameTalent .. " rank " .. currentRank);
elseif (englishClass == "WARLOCK") then
-- shadow focus
nameTalent, _, _, _, currentRank, maxRank = GetTalentInfo(1, 2);
hitTalent = currentRank;
--print(" hit talent : " .. nameTalent .. " rank " .. currentRank);
elseif (englishClass == "DRUID") then
-- balance of power
nameTalent, _, _, _, currentRank, maxRank = GetTalentInfo(1, 17);
hitTalent = currentRank*2;
--print(" hit talent : " .. nameTalent .. " rank " .. currentRank);
elseif (englishClass == "SHAMAN") then
-- elemental precision
nameTalent, _, _, _, currentRank, maxRank = GetTalentInfo(1, 14);
hitTalent = currentRank;
-- dual wield spe
nameTalent, _, _, _, currentRank, maxRank = GetTalentInfo(2, 19);
hitMeleeTalent = currentRank*2;
--print(" hit talent : " .. nameTalent .. " rank " .. currentRank);
elseif (englishClass == "ROGUE") then
-- precision
nameTalent, _, _, _, currentRank, maxRank = GetTalentInfo(2, 6);
hitMeleeTalent = currentRank;
elseif (englishClass == "HUNTER") then
-- focused aim
nameTalent, _, _, _, currentRank, maxRank = GetTalentInfo(2, 2);
hitMeleeTalent = currentRank;
elseif (englishClass == "WARRIOR") then
-- precision
nameTalent, _, _, _, currentRank, maxRank = GetTalentInfo(2, 13);
hitMeleeTalent = currentRank;
elseif (englishClass == "DEATHKNIGHT") then
-- Nerves of Cold Steel
nameTalent, _, _, _, currentRank, maxRank = GetTalentInfo(2, 6);
--have to test if one handed weapon
if (not twoHandedWeaponEquipped) then hitMeleeTalent = currentRank; end
end


end




-- hitDebuff
if (eventAuraTarget or (event == "PLAYER_TARGET_CHANGED")) then
hitDebuff = 0;
--print("target's auras changed");
  for i=1,40 do 
	local n,rank = UnitDebuff("target",i);
	local rankValue = 0;
	if (n==nil) then break; end 
	if (n == debuffNameMisery) then 
		--print("misery !!!")
		rankvalue = getValueFromString(rank);
		if (hitDebuff < rankvalue) then hitDebuff = rankvalue; end
	end 
	if (n == debuffNameFaerie) then 
		--print("imp faerie fire !!!")
		--rankvalue = getValueFromString(rank);
		--if (hitDebuff < rankvalue) then hitDebuff = rankvalue; end
		
		-- not statisfying at all but just test faerie fire debuf and apply 3%
		hitDebuff = 3
	end 
	if (hitDebuff == 3) then break; end
	--rankvalue = getValueFromString(rank);
	--print(n,rankvalue);
  end
end

if (eventAuraPlayer) then
 hitHero = 0;
 for i=1,40 do 
	local n = UnitAura("player",i);
	if (n==nil) then break; end 
	--print(n..", ");
	if (n == debuffNameHeroic) then hitHero = 1; break; end
  end
end

-- final calculation
PerfectHit.spellHit = hitLvl + hitStuff + hitDebuff + hitHero + hitTalent;
PerfectHit.meleeHit = hitMeleeLvl + hitMeleeStuff + hitHero + hitMeleeTalent;




-- display format
refreshDisplay();


end)

local function formatTip(value)
	return format("%.1f%%",value);
end

local myTip = nil;
function dataobj.OnTooltipShow(tip)
	if not tip or not tip.AddLine or not tip.AddDoubleLine then return end

	if not myTip then myTip = CreateFrame("GameTooltip", "PerfectHitTip") end
	
	tip:AddLine("perfect hit v0.5",0,1,0)
	tip:AddLine(" ")
	-- spell
	tip:AddDoubleLine(format("Меткость заклинаний против lvl%i",targetlvl), formatTip(hitLvl),1,1,1)
	tip:AddDoubleLine("Меткость заклинаний с посоха", formatTip(hitStuff),1,1,1)
	tip:AddDoubleLine("Меткость заклинаний с талантов", formatTip(hitTalent),1,1,1)
	tip:AddDoubleLine("Меткость заклинаний с аур", formatTip(hitDebuff + hitHero),1,1,1)
	if (hitStuff>0) then
	local deltaHit = PerfectHit.spellHit  - 100;
	local deltaHitRating = (deltaHit*hitStuffRating)/hitStuff; 
	local str = UnitName("target");
	if (str == nil) then str = "Ваш собственый уровень"; end
	if (deltaHit<0) then
		tip:AddLine(format("Нужно больше %i рейтинга меткости заклинаний",-deltaHitRating) ,1,0,0)
		tip:AddLine("против " .. str,1,0,0) 
	else
		tip:AddLine(format("Кап меткости заклинаний (%i превышеных очков)",deltaHitRating) ,0,1,0)
		tip:AddLine("против " .. str,0,1,0) 
	end
	
      end
	tip:AddLine(" ")
	-- melee
	tip:AddDoubleLine(format("Меткость ближнего боя против lvl%i",targetlvl), formatTip(hitMeleeLvl),1,1,1)
	tip:AddDoubleLine(format("Меткость боя двумя оружиями против lvl%i",targetlvl), formatTip(hitMeleeLvl-hitMeleeDual),1,1,1)
	tip:AddDoubleLine("Меткость ближнего боя с посоха", formatTip(hitMeleeStuff),1,1,1)
	tip:AddDoubleLine("Меткость ближнего боя с талантов", formatTip(hitMeleeTalent),1,1,1)
	tip:AddDoubleLine("Меткость ближнего боя с аур", formatTip(hitHero),1,1,1)
	if (hitMeleeStuff>0) then
	local deltaHit = PerfectHit.meleeHit  - 100;
	local deltaHitRating = (deltaHit*hitStuffRating)/hitMeleeStuff; 
	local str = UnitName("target");
	if (str == nil) then str = "Ваш собственый уровень"; end
	if (deltaHit<0) then
		tip:AddLine(format("Нужно больше %i рейтинга меткости в ближнем бою",-deltaHitRating) ,1,0,0)
		tip:AddLine("против " .. str,1,0,0) 
	else
		tip:AddLine(format("Кап меткости ближнего боя (%i превышеных очков)",deltaHitRating) ,0,1,0)
		tip:AddLine("против " .. str,0,1,0) 
	end
	
      end
	
end

function dataobj.OnClick()
	if (spellDisplay) then
	   spellDisplay = false;
	   --dataobj.icon = "Interface\\Icons\\Ability_BackStab"
	else
	   spellDisplay = true;
	   --dataobj.icon = "Interface\\Icons\\Ability_Mage_FrostFireBolt"
	end
	--PerfectHitSave.spellDisplay = spellDisplay
	refreshDisplay();
end
